var nbDroites=5;
function ggbOnInit() {
	
}

function valider() {
	var d=creerDroites();
	// est-ce le nombre de droites demandé?
	if(d!=nbDroites) {
		alert("Tu dois créer exactement "+nbDroites+" droites distinctes (non confondues). (Tu en as créé "+d+").");
	} else { 
	// si oui, afficher un message et écrire l'analyse dans la case adéquate du tableur
		var p=creerPoints();
		var analyse=analyser(p);
		var message="";
		var dejaFait=(ggbApplet.getValueString("B"+(p+2))=="ok");
		if(!dejaFait) {
			message="Bravo! C'est une configuration à "+p+" point(s).";
		} else {
			message="C'est encore une configuration à "+p+" point(s).";
		}
		var hc=pointsHorsChamp(p);
		if(hc>0) {
			message=message+" Il y a "+hc+" point(s) d'intersection hors de l'écran : tu peux utiliser le zoom pour le(s) voir.";
		}
		alert(message);
		ggbApplet.setTextValue("B"+(p+2),"ok");
		ggbApplet.evalCommand("SetBackgroundColor(B"+(p+2)+",0,255,0)");
		ggbApplet.setTextValue("C"+(p+2),analyse);
	}
}

function creerDroites() {
	// compter et nommer les droites créées (confondues ou non)
	var n=ggbApplet.getObjectNumber();
	var d=0;
	for(i=0;i<n;i++) {
		var nomObjet=ggbApplet.getObjectName(i);
		var typeObjet=ggbApplet.getObjectType(nomObjet);
		if(typeObjet=="line"){
			d++;
			ggbApplet.renameObject(nomObjet,"D_{"+d+"}");
		}
	}
	// repérer les droites confondues
	var e=d;
	for(i=1;i<=d;i++){
		for(j=i+1;j<=d;j++){
			if(ggbApplet.exists("D_{"+i+"}")&&ggbApplet.exists("D_{"+j+"}")){
				ggbApplet.evalCommand("Test=(D_{"+i+"}==D_{"+j+"})");
				var confondues=ggbApplet.getValue("Test");
				if(confondues) {
					ggbApplet.deleteObject("D_{"+j+"}");
					e=e-1;
				}
			}
		}
	}
	// renommer les droites distinctes de 1 à e
	var j=0;
	for(i=1;i<=d;i++){
		if(ggbApplet.exists("D_{"+i+"}")){
			j++;
			ggbApplet.renameObject("D_{"+i+"}","d_{"+j+"}");
			ggbApplet.setLabelVisible("d_{"+j+"}",true);
		}
	}
	// cacher les points libres qui ont servi à créer les droites
	for(i=0;i<n;i++) {
		var nomObjet=ggbApplet.getObjectName(i);
		var typeObjet=ggbApplet.getObjectType(nomObjet);
		if(typeObjet=="point"){
			ggbApplet.setVisible(nomObjet,false);
		}
	}
	// renvoyer le nombre de droites distinctes
	return e;
}

function creerPoints() {
	// créer et nommer tous les points d'intersection
	var p=0;
	for(i=1;i<=nbDroites;i++){
		for(j=i+1;j<=nbDroites;j++){
			ggbApplet.evalCommand("Test=d_{"+i+"}∥d_{"+j+"}");
			var paralleles=ggbApplet.getValue("Test");
			if(!paralleles){
				p++;
				ggbApplet.evalCommand("Q_{"+p+"}=Intersect(d_{"+i+"},d_{"+j+"})");
			}
		}
	}
	// repérer les points confondus
	for(i=1;i<=p;i++){
		for(j=i+1;j<=p;j++){
			if(ggbApplet.exists("Q_{"+i+"}")&&ggbApplet.exists("Q_{"+j+"}")){
				ggbApplet.evalCommand("Test=(Q_{"+i+"}==Q_{"+j+"})");
				var confondus=ggbApplet.getValue("Test");
				if(confondus){
					ggbApplet.deleteObject("Q_{"+j+"}");
				}
			}
		}
	}
	// renommer les points distincts de 1 à q
	var q=0;
	for(i=1;i<=p;i++){
		if(ggbApplet.exists("Q_{"+i+"}")) {
			q++;
			ggbApplet.renameObject("Q_{"+i+"}","P_{"+q+"}");
			ggbApplet.setLabelVisible("P_{"+q+"}",true);
			ggbApplet.setColor("P_{"+q+"}",255,0,0);
		}
	}
	// renvoyer le nombre de points distincts
	return q;
}

function pointsHorsChamp(p) {
	// compter les points d'intersection non visibles
	var h=0;
	for(j=1;j<=4;j++) {
		ggbApplet.evalCommand("Coin"+j+"=Corner("+j+")");
		ggbApplet.setVisible("Coin"+j,false);
	}
	ggbApplet.evalCommand("ecran=Polygon(Coin1,Coin2,Coin3,Coin4)");
	ggbApplet.setVisible("ecran",false);
	for(i=1;i<=p;i++) {
		ggbApplet.evalCommand("Test=IsInRegion(P_{"+i+"},ecran)");
		var pointDansEcran=ggbApplet.getValue("Test");
		if(!pointDansEcran) {
			h++;
		}
	}
	return h;
}

function recommencer(){
	ggbApplet.reset();
}

function nouvelleConfiguration(){
	// effacer tous les points et toutes les droites
	var n=ggbApplet.getObjectNumber();
	var poubelle=[];
	var npoubelle=0;
	for(i=0;i<n;i++){
		var nomObjet=ggbApplet.getObjectName(i);
		var typeObjet=ggbApplet.getObjectType(nomObjet);
		if((typeObjet=="line")||(typeObjet=="point")){
			poubelle[npoubelle]=nomObjet;
			npoubelle++;
		}
	}
	for(i=0;i<npoubelle;i++){
		ggbApplet.deleteObject(poubelle[i]);
	}
}

function analyser(p) {
	var analyse="";
	// Droites parallèles?
	var listeDroites=[];
	for(i=1;i<=nbDroites;i++) {
		listeDroites[i]=0;	
	}
	for(i=1;i<=nbDroites;i++){
		if(listeDroites[i]==0) {
			var listeParalleles=["d"+i];
			var nbParalleles=0;
			for(j=i+1;j<=nbDroites;j++){
				ggbApplet.evalCommand("Test=d_{"+i+"}∥d_{"+j+"}");
				var paralleles=ggbApplet.getValue("Test");
				if(paralleles){
					nbParalleles++;
					listeParalleles[nbParalleles]="d"+j;
					listeDroites[i]=1;
					listeDroites[j]=1;		
				}
			}
			if(nbParalleles>=1) {
				if(analyse!="") {
					analyse=analyse+" - ";
				} 
				analyse=analyse+"d"+i;
				for(k=1;k<=nbParalleles;k++) {
					analyse=analyse+"∥"+listeParalleles[k];
				}
			}
		}
	}
	// Droites concourantes?
	for(i=1;i<=p;i++) {
		var listeDroitesPassant="";
		var nbDroitesPassant=0;
		for(j=1;j<=nbDroites;j++) {
			ggbApplet.evalCommand("Test=(Distance[P_{"+i+"},d_{"+j+"}]==0)");
			var passe=ggbApplet.getValue("Test");
			if(passe) {
				if(nbDroitesPassant==0) {
					listeDroitesPassant="d"+j;
				} else {
					listeDroitesPassant=listeDroitesPassant+",d"+j;
				}
				nbDroitesPassant++;
			}
		}
		if(nbDroitesPassant>=3) {
			if(analyse!="") {
				analyse=analyse+" - ";
			}
			analyse=analyse+listeDroitesPassant+" concourantes";
		}
	}
	return(analyse);
}

function terminer(){
	// faire le bilan de ce qui a été réussi et de ce qui était impossible
	var possibles=[1,1,0,0,1,1,1,1,1,1,1];
	var reussites=[0,0,0,0,0,0,0,0,0,0,0];
	var echecs="";
	for(i=0;i<=10;i++) {
		reussites[i]=(ggbApplet.getValueString("B"+(i+2))=="ok");
	}
	for(i=0;i<=10;i++) {
		if(possibles[i]&&!reussites[i]) {
			if(echecs=="") {
				echecs=""+i;
			} else {
				echecs=echecs+","+i;
			}
		}
	}
	var message="";
	if(echecs=="") {
		message="Bravo! Tu as trouvé toutes les configurations possibles.";
	} else {
		message="Les configurations avec "+echecs+" point(s) d'intersection sont possibles! Cherche encore..."
	}
	message=message+"\n"+"Les configurations avec 2 points et 3 points d'intersection sont impossibles, et on ne peut pas non plus obtenir plus de 10 points d'intersection.";
	alert(message);
}
